﻿[CmdletBinding()]
Param([string]$Feature,
[string]$RemoteIPs = $null,
[string]$ClusterMemberIPs = $null
)

$WMIPs = $RemoteIPs -split ",";
$ClusterIPs = $ClusterMemberIPs -split ",";

If ($Feature -eq "DE") {
New-NetFirewallRule -DisplayName "SQL Server" -Profile @("Domain","Private") -Direction Inbound -Action Allow -Protocol TCP -LocalPort "1433" -RemoteAddress $WMIPs ;
}

If ($Feature -eq "Browser") {
New-NetFirewallRule -DisplayName "SQL Server Browser" -Profile @("Domain","Private") -Direction Inbound -Action Allow -Protocol UDP -LocalPort "1434" -RemoteAddress $WMIPs;
}

If ($Feature -eq "WSFC") {
Enable-NetFirewallRule -DisplayName "Network Discovery (NB-Name-In)"; # ClusterAdmin UDP Port 137
Enable-NetFirewallRule -DisplayName "Failover Clusters (TCP-In)"; # Cluster Svc TCP Port 3343
Enable-NetFirewallRule -DisplayName "Failover Clusters (UDP-In)"; # Cluster Svc UDP Port 3343
Enable-NetFirewallRule -DisplayName "Failover Clusters (DCOM-RPC-EPMAP-In)"; # Cluster Svc RPC TCP Port 135
Write-Output "IPs: $ClusterIPs";
New-NetFirewallRule -DisplayName "Failover Clusters (Random UDP Ports)" -Direction Inbound -Action Allow -Protocol UDP -LocalPort "49152-65535" -RemoteAddress $ClusterIPs;
New-NetFirewallRule -DisplayName "Failover Clusters (Random TCP Ports)" -Direction Inbound -Action Allow -Protocol TCP -LocalPort "49152-65535" -RemoteAddress $ClusterIPs;
New-NetFirewallRule -DisplayName "SQL Endpoints" -Direction Inbound -Action Allow -Protocol TCP -LocalPort "5022" -RemoteAddress $WMIPs;
}

If ($Feature -eq "Filestream") {
New-NetFirewallRule -DisplayName "SQL Server Filestream" -Profile @("Domain","Private") -Direction Inbound -Action Allow -Protocol TCP -LocalPort "139,445" -RemoteAddress $WMIPs ;
}

If ($Feature -eq "SSIS") {
New-NetFirewallRule -DisplayName "SQL Server Integration Services" -Profile @("Domain","Private") -Direction Inbound -Action Allow -Protocol TCP -LocalPort "135" -RemoteAddress $WMIPs ;
New-NetFirewallRule -DisplayName "SQL Server Integration Services" -Profile @("Domain","Private") -Direction Inbound -Action Allow -Program "%ProgramFiles%\Microsoft SQL Server\110\DTS\Binn\MsDtsSrvr.exe";
}

If ($Feature -eq "SSRS") {
New-NetFirewallRule -DisplayName "SQL Server Reporting Services" -Profile @("Domain","Private") -Direction Inbound -Action Allow -Protocol TCP -LocalPort "80,443";
}

If ($Feature -eq "SSAS") {
New-NetFirewallRule -DisplayName "SQL Server Analysis Services" -Profile @("Domain","Private") -Direction Inbound -Action Allow -Protocol TCP -LocalPort "2383" -RemoteAddress $WMIPs ;
}
