﻿[CmdletBinding()]
Param([string]$ClusterName = "sql-wmpd-clst",
[array]$ClusterMembers = @("sql-wmpd1","sql-wmpd2"),
[string]$ClusterIPAddress = "10.3.20.28",
[string]$MgmtIPRange = "10.3.2.0/24",
[string]$FileShareSecurityGroup = $null
)

Import-Module ActiveDirectory;
Import-Module FailoverClusters;

$ClusterList = [string]::Join(",",$ClusterMembers);

Write-Output "Cluster Nodes: $ClusterList";
Test-Cluster -Node sql-wmpd1.campus.wm.edu, sql-wmpd2.campus.wm.ed;
#Test-Cluster -Node $ClusterList;
#New-Cluster -Name $ClusterName -Node $ClusterList -NoStorage -StaticAddress $ClusterIPAddress -IgnoreNetwork $MgmtIPRange;
#Add-ADGroupMember $FileShareSecurityGroup -Members "$ClusterName$"; 
#Set-ClusterQuorum -FileShareWitness $FileShareWitness;
#Start-Cluster;


<#
$ClusterList = [string]::Join(",",$ClusterMembers);

$WSFCBlock = @"
Import-Module ActiveDirectory;
Import-Module FailoverClusters;
Test-Cluster -Node $ClusterList;
"@
New-Cluster -Name $ClusterName -Node $ClusterList -NoStorage -StaticAddress $ClusterIPAddress -IgnoreNetwork $MgmtIPRange;
Add-ADGroupMember $FileShareSecurityGroup -Members "$ClusterName$"; 
"@
$WSFCBlock = $ExecutionContext.InvokeCommand.NewScriptBlock($WSFCBlock)

Invoke-Command -ComputerName $Server -ScriptBlock $WSFCBlock -Credential $pscred;

$continue = Read-Host "Grant Cluster Object access to Witness File Share";

$WSFCBlock = @"
Import-Module FailoverClusters;
Set-ClusterQuorum -FileShareWitness $FileShareWitness;
Start-Cluster;
"@
Invoke-Command -ComputerName $Server -ScriptBlock {$WSFCBlock};
}
#>