﻿[CmdletBinding()]
Param (	[string]$ScriptPath = "\\jonesfiles\windump$\ServerConfig\mssql\Install", # No trailing \ on folder name
        [ValidateSet(2012,2014,2016,2017)][string]$SQLVersion = "2017"
)

# Get current Powershell version
$PSVersion = $PSVersionTable.PSVersion.Major;
Write-Output "Current PowerShell version $PSVersion";

# Install PS module
If ($PSVersion -le 4 -and $SQLVersion -ge "2016") {

    #######################################################################
    # For PowerShell v3 & v4 install PowerShellGet module from:           #
    # https://www.microsoft.com/en-us/download/confirmation.aspx?id=51451 #
    #######################################################################

    write-output "Install PowerShellGet";
    Start-Process "$env:systemroot\system32\msiexec.exe" -verb runas -ArgumentList "/i `"$ScriptPath\Config_Scripts\PackageManagement_x64.msi`" /passive /norestart /log `"$ScriptPath\PS_log.txt`"" -Wait

    ##################################################################
    # Upgrade PS version                                             #
    # https://www.microsoft.com/en-us/download/details.aspx?id=50395 #
    ##################################################################

    write-output "***** Upgrade to PS v5 Required *****";
    write-output "***** Download & Install Win8.1AndW2K12R2-KB3134758-x64.msu *****";
    write-output "***** https://www.microsoft.com/en-us/download/details.aspx?id=50395 *****";

    Write-Output "Manual Download and Install PowerShell Required."
    Exit
}

If (($PSVersion -ge 5) -and ($SQLVersion -ge "2016")) {
    write-output "Install NuGet";
    Install-PackageProvider -Name NuGet -MinimumVersion 2.8.5.201 -Force -Scope allusers;

    write-Output "Install SQLServer PS modules";
    Install-Module SQLServer -Force -Scope AllUsers -AllowClobber;

    Write-Output "PowerShell Update Complete.";
}
